<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat="server">

  void Page_Load(Object sender, EventArgs e) {

     if (!Page.IsPostBack) BindCategories();

  }

  void BindCategories() {

      // Create Instance of Connection and Command Object
      SqlConnection cn = new 
        SqlConnection("server=localhost;uid=sa;pwd=;database=northwind");
      SqlDataAdapter adapter = new 
        SqlDataAdapter("select * from categories", cn);

      DataSet myDataSet = new DataSet();
      adapter.Fill(myDataSet, "categories");

      Categories.DataSource = new DataView(myDataSet.Tables["categories"]);
      Categories.DataBind();

  }

  void BindProducts(Object sender, EventArgs e) {

    // Determine which category was selected
    int catId = (int)Categories.DataKeys[Categories.SelectedIndex];

    // Add the Product Header
    ProductHeader.Text = "Products for Category: " + catId.ToString();

     // Create Instance of Connection and Command Object
      SqlConnection cn = new 
        SqlConnection("server=localhost;uid=sa;pwd=;database=northwind");
      SqlDataAdapter adapter = new SqlDataAdapter(
        "select * from products where categoryid = " + catId, cn);

      DataSet myDataSet = new DataSet();
      adapter.Fill(myDataSet, "products");

      Products.DataSource = new DataView(myDataSet.Tables["products"]);
      Products.DataBind();

  }

</script>

<html>
<head>
    <title>Master/Detail with the DataGrid and DataList</title>
</head>

<body>

<h1>Master/Detail with the DataGrid and DataList</h1>
<hr>

<form runat="server" id=form1 name=form1>

<asp:DataGrid runat="server" id="Categories"
  BorderColor="black"
  BorderWidth="1"
  GridLines="Both"
  CellPadding="3"
  CellSpacing="0"
  Font-Name="Verdana"
  Font-Size="8pt"
  AutoGenerateColumns="false"
  HeaderStyle-BackColor="silver"
  HeaderStyle-Font-Bold="true"
  DataKeyField="CategoryID"
  OnSelectedIndexChanged="BindProducts">

  <Columns>

    <asp:ButtonColumn
       HeaderStyle-Width="100px"
       HeaderText="View Products"
       Text="Select"
       CommandName="Select"/>

    <asp:BoundColumn
       HeaderStyle-Width="100px"
       HeaderText="ID"
       DataField="CategoryId"/>

    <asp:BoundColumn
       HeaderStyle-Width="200px"
       HeaderText="Category Name"
       DataField="CategoryName"/>

  </Columns>

</asp:DataGrid>

<br>
<b><asp:Label id="ProductHeader" runat="server"/></b>
<br><br>

<asp:DataList id="Products" runat="server"
   BorderColor="black"
   CellPadding="3"
   BorderWidth="1"
   GridLines="Both"
   RepeatColumns="2"
   RepeatDirection="Horizontal"
   ItemStyle-Width="50%"
   Font-Name="Verdana"
   Font-Size="8pt"
   HeaderStyle-BackColor="#aaaadd">

   <ItemTemplate>

      <b>Product Name:</b>
      <%# DataBinder.Eval(Container.DataItem, "ProductName") %>
      <br>
      <b>ProductID:</b>
      <%# DataBinder.Eval(Container.DataItem, "ProductId") %>
      <br>
      <b>Units In Stock:</b>
      <%# DataBinder.Eval(Container.DataItem, "UnitsInStock") %>
      <br>
      <b>Unit Price:</b>
      <%# DataBinder.Eval(Container.DataItem, "UnitPrice", "{0:c}") %>
      <br>

   </ItemTemplate>

</asp:DataList>

</form>

</body>
</html>
