<% @Page Language="C#" Debug="True" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<HTML>
<HEAD>
    <LINK rel="stylesheet" type="text/css" href="Main.css">
    <!-- End Style Sheet -->

    <script language="C#" runat="server" >
      void Page_Load(Object Source, EventArgs E)
      {
        if(IsPostBack==true) {
            //Create and Open Connection
            SqlConnection nwConn = new SqlConnection(
              "Data Source=localhost;UID=sa;PWD=;Initial Catalog=northwind;");
            nwConn.Open();

            //Create Command
            SqlCommand nwCmd = new SqlCommand("AddNewEmployee", nwConn);
            nwCmd.CommandType = CommandType.StoredProcedure;

            //Setup the following Input and Output Parameters
            /*
               Name             Size
               ---------------------
               @LastName        20
               @FirstName       10
               @HireDate        8
               @Address         60
               @City            15
               @Extension       4
            */

            SqlParameter nwParam = null;

            nwParam = nwCmd.Parameters.Add(new SqlParameter("@LastName", 
                                                     SqlDbType.NVarChar, 20));
            nwParam.Direction = ParameterDirection.Input;
            nwParam.Value = sLastName.Text;

            nwParam = nwCmd.Parameters.Add(new SqlParameter("@FirstName", 
                                                     SqlDbType.NVarChar, 10));
            nwParam.Direction = ParameterDirection.Input;
            nwParam.Value = sFirstName.Text;

            nwParam = nwCmd.Parameters.Add(new SqlParameter("@HireDate", 
                                                     SqlDbType.NVarChar, 8));
            nwParam.Direction = ParameterDirection.Input;
            nwParam.Value = sHireDate.Text;

            nwParam = nwCmd.Parameters.Add(new SqlParameter("@Address", 
                                                     SqlDbType.NVarChar, 60));
            nwParam.Direction = ParameterDirection.Input;
            nwParam.Value = sAddress.Text;

            nwParam = nwCmd.Parameters.Add(new SqlParameter("@City", 
                                                     SqlDbType.NVarChar, 15));
            nwParam.Direction = ParameterDirection.Input;
            nwParam.Value = sCity.Text;

            nwParam = nwCmd.Parameters.Add(new SqlParameter("@Extension", 
                                                     SqlDbType.NVarChar, 4));
            nwParam.Direction = ParameterDirection.Input;
            nwParam.Value = sExtension.Text;

            nwParam = nwCmd.Parameters.Add(new SqlParameter("@retval", 
                                                     SqlDbType.Int, 4));
            nwParam.Direction = ParameterDirection.Output;

            nwCmd.ExecuteNonQuery();
            msg.Text = "New Employee Added with EmployeeID '" 
                           + nwParam.Value + "'";
            }
      }
    </script>

</HEAD>
<BODY>

<h1>Using Stored Procedures With Parameters (with output)</h1>
<hr>

<form runat="server" id=form1 name=form1>

  <asp:Label id=msg runat="server">
    Please Enter The Following Information 
    To Add A New Employee To The NorthWinds DB
  </asp:Label>

  <p>
  <table>
    <tr>
        <td>
            First Name:
        </td>
        <td>
            <asp:TextBox id=sFirstName runat=server></asp:TextBox>
        </td>
    </tr>
    <tr>
        <td>
            Last Name:
        </td>
        <td>
            <asp:TextBox id=sLastName runat=server></asp:TextBox>
        </td>
    </tr>
    <tr>
        <td>
            Hire Date:
        </td>
        <td>
            <asp:TextBox id=sHireDate runat=server></asp:TextBox>
        </td>
    </tr>
    <tr>
        <td>
            Address:
        </td>
        <td>
            <asp:TextBox id=sAddress runat=server></asp:TextBox>
        </td>
    </tr>
    <tr>
        <td>
            City:
        </td>
        <td>
            <asp:TextBox id=sCity runat=server></asp:TextBox>
        </td>
    </tr>
    <tr>
        <td>
            Extension:
        </td>
        <td>
            <asp:TextBox id=sExtension runat=server></asp:TextBox>
        </td>
    </tr>
    <tr>
        <td colspan=2>
            <input type=submit id=submit1 name=submit1>
        </td>
    </tr>
  </table>
  </p>
</form>
<hr>

</BODY>
</HTML>
