CREATE PROCEDURE AccountsDebit 
(
    @AccountId int,
    @Amount money
)
AS

DECLARE @Test_Success int
DECLARE @Test_Balance int

SELECT 
    @Test_Success = Count(AccountId) 
FROM
    Accounts
WHERE
    AccountId = @AccountId

IF (@test_Success < 1)
    RAISERROR('The source account ID, %d, is invalid.', 16, 1, @AccountId)

SELECT
    @Test_Balance = Balance
FROM
    Accounts
WHERE
    AccountId = @AccountId

IF (@Test_Balance < @Amount)
	RAISERROR('Debit amount is greater than balance', 16, 1)
ELSE
BEGIN

UPDATE
  Accounts
SET
  Balance = Balance - @Amount
WHERE
  AccountId = @AccountId

END
GO
