using System;
using System.Data;
using System.Data.SqlClient;
using System.EnterpriseServices;
using System.Reflection;

[assembly: ApplicationName("Accounts")]
[assembly: AssemblyKeyFileAttribute("Accounts.snk")]

namespace PureASP
{

  [Transaction(TransactionOption.Required)]
  public class Accounts:ServicedComponent
  {

    [AutoComplete(true)]
    public bool ExecuteTransaction(
      int amount, int sourceAccountId, int targetAccountId)
    {
      Exception eSourceTargetIdentical = 
        new Exception("Source and target accounts cannot be the Same");

      if (sourceAccountId == targetAccountId)
      throw (eSourceTargetIdentical);

      //debit the source account
      DebitAccount(sourceAccountId, amount);

      //credit the target account
      CreditAccount(targetAccountId, amount);

      return true;

    }

    public static SqlDataReader ListAccounts() 
    {
  
      SqlConnection conn = new SqlConnection();
      SqlCommand cmd = new SqlCommand();

      conn.ConnectionString = "server=localhost;uid=sa;pwd=;database=accounts";

      cmd.CommandText = "AccountsList";
      cmd.CommandType = CommandType.StoredProcedure;
      cmd.Connection = conn;

      conn.Open();
      SqlDataReader result = 
        cmd.ExecuteReader(CommandBehavior.CloseConnection);

      return result;

    }

    public static SqlDataReader ListAccountDetails()
    {

      SqlConnection conn = new SqlConnection();
      SqlCommand cmd = new SqlCommand();

      conn.ConnectionString = "server=localhost;uid=sa;pwd=;database=accounts";

      cmd.CommandText = "AccountsListDetails";
      cmd.CommandType = CommandType.StoredProcedure;
      cmd.Connection = conn;

      conn.Open();
      SqlDataReader result = 
        cmd.ExecuteReader(CommandBehavior.CloseConnection);

      return result;
     
    }

    private void UpdateAccount(string command, int accountId, int amount) 
    {

      Exception eInvalidCommand = new Exception("Invalid Command");

      SqlConnection conn = new SqlConnection();
      SqlCommand cmd = new SqlCommand();

      conn.ConnectionString = "server=localhost;uid=sa;pwd=;database=accounts";

      if (command == "DEBIT")
        cmd.CommandText = "AccountsDebit";

      else if (command == "CREDIT")
        cmd.CommandText = "AccountsCredit";

      else
        throw(eInvalidCommand);

      cmd.CommandType = CommandType.StoredProcedure;
      cmd.Connection = conn;

      // add parameters
      SqlParameter pAccId = new SqlParameter("@AccountId", SqlDbType.Int, 4);
      pAccId.Value = accountId;
      cmd.Parameters.Add(pAccId);

      // add parameters
      SqlParameter pAmt = new SqlParameter("@Amount", SqlDbType.Int, 4);
      pAmt.Value = amount;
      cmd.Parameters.Add(pAmt);

      conn.Open();
      cmd.ExecuteNonQuery();

    }

    protected void CreditAccount(int accountId, int amount) 
    {

      UpdateAccount("CREDIT", accountId, amount);

    }

    protected void DebitAccount(int accountId, int amount) 
    {

      UpdateAccount("DEBIT", accountId, amount);

    }

  }

}
