<% @Page Language="C#" debug="true"%>
<% @Import Namespace="PureASP" %>

<script runat="server">

  void Page_Load(Object src, EventArgs e) {

    if (!Page.IsPostBack) DisplayAccountSummary();

  }

  void DisplayAccountSummary() {

    SourceAccount.DataSource = Accounts.ListAccounts();
    TargetAccount.DataSource = Accounts.ListAccounts();
    AccountSummary.DataSource = Accounts.ListAccountDetails();

    Page.DataBind();
    
  }

  void ExecuteTransaction(Object src, EventArgs e) {

    if (Page.IsValid) {
      
      int amt = Int32.Parse(Amount.Text);
      int tgtAcct = Int32.Parse(TargetAccount.SelectedItem.Value);
      int srcAcct = Int32.Parse(SourceAccount.SelectedItem.Value);

      PureASP.Accounts acc = new PureASP.Accounts();
      acc.ExecuteTransaction(amt, srcAcct, tgtAcct);

      DisplayAccountSummary();

      Result.Text = "Successfully Transferred $" + Amount.Text;// + 
       // "from " + SourceAccount.SelectedItem.Text + " to " +
       // TargetAccount.SelectedItem.Text;

    }

  }

</script>

<html>
  <head>
    <title>COM+ Transactions Example</title>
  </head>
  <body>
    <form id="frm" method="post" runat="server">
      <p>
        <asp:Label id="Label3" runat="server" Font-Bold="True" Font-Size="14pt"
           Font-Names="Verdana">COM+ Transactions Example</asp:Label>
      </p>
      <p>
        <asp:DataGrid runat="server" width="300" id="AccountSummary" 
          cellpadding="3">
            <HeaderStyle Font-Size="8pt" Font-Names="Verdana" 
              Font-Bold="True" ForeColor="Black" BackColor="Beige" />
            <ItemStyle Font-Size="8pt" Font-Names="Verdana" />          
        </asp:DataGrid>
      </p>
      <p>
        <asp:Label id="Label4" runat="server" Font-Bold="True" 
          Font-Size="10pt" Font-Names="Verdana">Transfer Amount (Integer):
        </asp:Label>
         &nbsp;
        <asp:TextBox id="Amount" runat="server" />
      </p>
      <table cellSpacing="0" cellPadding="5" width="400" border="0">
        <tr>
          <td width="200">
            <asp:Label id="Label1" runat="server" Font-Bold="True" 
              Font-Size="10pt" Font-Names="Verdana" Text="Transfer From: " />
          </td>
          <td width="200">
            <asp:Label id="Label2" runat="server" Font-Bold="True" 
              Font-Size="10pt" Font-Names="Verdana" Text="Transfer To: " />
          </td>
        </tr>
        <tr>
          <td width="200">
            <asp:RadioButtonList id="SourceAccount" runat="server" 
              Font-Size="8pt" Font-Names="Verdana" DataTextField="AccountName"
              DataValueField="AccountId" />
          </td>
          <td width="200">
            <asp:RadioButtonList id="TargetAccount" runat="server" 
              Font-Size="8pt" Font-Names="Verdana" DataTextField="AccountName"
              DataValueField="AccountId" />
          </td>
        </tr>
      </table>
      <p>
        <asp:Button id="Button1" runat="server" Font-Bold="True" 
          Text="Execute Transaction" BackColor="Beige" 
          OnClick="ExecuteTransaction" />
      </p>
      <asp:Label runat="server" id="Result" Font-Size="10pt" 
        Font-Names="Verdana" Forecolor="red"/>
    </form>
  </body>
</html>
