'*******************************************************
'
' InstantOrder.OrderItem() Method
'
' The OrderItem method enables a remote client to programmatically
' place an order using a webservice.
'
'*******************************************************

Public Function <WebMethod()> OrderItem(userName As String, _
            password As String, productID As Integer, _
            quantity As Integer) As OrderDetails

    ' Login client using provided username and password
    Dim accountSystem As IBuySpy.CustomersDB = New IBuySpy.CustomersDB()
    Dim customerId As String = accountSystem.Login(userName, password)

    If customerId = Nothing Then
        throw new Exception("Error: Invalid Login!")
    End If

    ' Add Item to Shopping Cart
    Dim myShoppingCart As IBuySpy.ShoppingCartDB = New IBuySpy.ShoppingCartDB()
    myShoppingCart.AddItem(customerId, productID, quantity)

    ' Place Order
    Dim orderSystem As IBuySpy.OrdersDB = New IBuySpy.OrdersDB()
    Dim orderID As Integer = orderSystem.PlaceOrder(customerId, customerId)

    ' Return OrderDetails
    Return orderSystem.GetOrderDetails(orderID)

End Function
